{License, info, etc
 ------------------

This implementation is made by me, Walied Othman, to contact me
mail to Walied.Othman@belgacom.net or Triade@ulyssis.org,
always mention wether it 's about the FGInt for Delphi or for
FreePascal, or wether it 's about the 6xs, preferably in the subject line.
If you 're going to use these implementations, at least mention my
name or something and notify me so I may even put a link on my page.
This implementation is freeware and according to the coderpunks'
manifesto it should remain so, so don 't use these implementations
in commercial software.  Encryption, as a tool to ensure privacy
should be free and accessible for anyone.  If you plan to use these
implementations in a commercial application, contact me before
doing so, that way you can license the software to use it in commercial
Software.  If any algorithm is patented in your country, you should
acquire a license before using this software.  Modified versions of this
software must contain an acknowledgement of the original author (=me).
This implementation is available at
http://triade.studentenweb.org

copyright 2000, Walied Othman
This header may not be removed.
}

unit FGIntPrimeGeneration;

interface

uses SysUtils, FGInt;

procedure PrimeSearch(var GInt: TFGInt);

implementation


{$H+}


// Does an incremental search for primes starting from GInt,
// when one is found, it is stored in GInt

procedure PrimeSearch(var GInt: TFGInt);
var
  temp, two: TFGInt;
  ok: Boolean;
begin
  if (GInt.Number[1] mod 2) = 0 then
    GInt.Number[1] := GInt.Number[1] + 1;
  Base10StringToFGInt('2', two);
  ok := false;
  while not ok do
  begin
    FGIntAdd(GInt, two, temp);
    FGIntCopy(temp, GInt);
    FGIntPrimeTest(GInt, 4, ok);
  end;
  FGIntDestroy(two);
end;

end.

